function love.load()
	--love.window.setMode(1280, 720)

	--min_dt = 1/30
    time_to_load = love.timer.getTime()
	next_time = love.timer.getTime()

	WINDOW_WIDTH = 1280
	WINDOW_HEIGHT = 720

	-- define types of tiles
	tile_type = {
		stone_floor = {
			id = 1,
			char_pool = {',', '.', '`', '\'', ';', ':'},
			char = '',
			pallete = {
						{62,0,0},
						{85,0,0},
						{121,0,0},
						{125,73,0},
						{157,10,14},
						{160,65,13}
					},
			color = {},

			passable = true
		},
		stone_wall = {
			id = 2,
			char = '#',
			pallete = {
						{37,37,37},
						{54,54,54}
					},
			color = {},

			passable = false
		}
	}
    
    for k,v in pairs(tile_type) do
        v.__index = v 
    end

	-- create map
	map = {}
	for i=1, 45, 1 do
		map[i] = {}
		for j=1, 27, 1 do
			map[i][j] = insert_tile('stone_floor')
		end
	end

	for i=1, 45, 1 do
		map[i][1] = insert_tile('stone_wall')
	end

	font_16 = love.graphics.setNewFont('cour.ttf', 16)
    
    time_to_load = love.timer.getTime() - time_to_load
end

function insert_tile(type)
	local tile, rand, color
	if		type == 'stone_floor' then
		-- make a copy of the tile
		tile = setmetatable({}, tile_type.stone_floor)
		-- choose random character
		rand = math.random(1, #tile.char_pool)
		tile.char = tile.char_pool[rand]
		-- and random color
		rand = math.random(1, #tile.pallete)
		tile.color = tile.pallete[rand]
		tile.char_pool = nil
		tile.pallete = nil
	elseif	type == 'stone_wall' then
		tile = setmetatable({}, tile_type.stone_wall)
		tile.color = {54,54,54}
	end
	return tile
end

function love.update(dt)
	--next_time = next_time + min_dt
end

function love.draw()
	love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 600, 10)
    love.graphics.print("Time to load: "..tostring(time_to_load), 600, 30)

	love.graphics.setFont(font_16)
	for i=1, 45, 1 do
		for j=1, 27, 1 do
			love.graphics.setColor(map[i][j].color)
			love.graphics.print(map[i][j].char, (i-1) * 12, (j-1) * 19)
		end
	end

	local cur_time = love.timer.getTime()
	if next_time <= cur_time then
		next_time = cur_time
		return
	end
	love.timer.sleep(next_time - cur_time)
end

function deepcopy(orig)
	local orig_type = type(orig)
	local copy
	if orig_type == 'table' then
		copy = {}
		for orig_key, orig_value in next, orig, nil do
			copy[deepcopy(orig_key)] = deepcopy(orig_value)
		end
	else -- number, string, boolean, etc
		copy = orig
	end
	return copy
end